/***
 * Excerpted from "No Fluff Just Stuff 2006 Anthology"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/nfjs06 for more book information.
***/
package net.bosatsu.util.regex.account;

import java.util.regex.Matcher;
import net.bosatsu.util.regex.io.Transformer;

/**
 * A concrete implementation of the Transformer interface
 * that transforms an account ID selected via a regular expression
 * by looking up a different account ID from some service.
 *
 * @author bsletten
 */

public class AccountRegularExpressionTransformer implements Transformer
{
    public String transform(Matcher m) {
        String oldAccount = m.group();
        return AccountService.getNewAccount( oldAccount );
    }
}
