/***
 * Excerpted from "No Fluff Just Stuff 2006 Anthology"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/nfjs06 for more book information.
***/
package net.bosatsu.util.regex.cc;

import java.util.regex.Matcher;

import net.bosatsu.util.regex.io.Transformer;

/**
 * A concrete implementation of the Transformer interface that simply masks
 * a 16-digit credit card by concatenating the last four digits to a bunch
 * of Xs. A real implementation of this would need to guarantee the validity
 * of the credit card (rather than simply matching digits) and to support
 * different credit card lengths.
 *
 * @author bsletten
 */
public class CCMaskRegularExpressionTransformer implements Transformer {
    public String transform(Matcher m) {
        String retValue = "XXXXXXXXXXXX" + m.group().substring( 12 );
        return retValue;
    }
}
