/***
 * Excerpted from "No Fluff Just Stuff 2006 Anthology"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/nfjs06 for more book information.
***/
package net.bosatsu.util.regex.io;

import java.util.regex.Matcher;

/**
 * An interface representing a potential transformation of any matches
 * found by a compiled regular expression pattern. The results of the
 * match are accessible to the Transformer via the Matcher instance
 * provided to the transform method.
 *
 * @author dsletten
 *
 */
public interface Transformer {
    /*
     * The return result will likely represent a transformed version of
     * the input String.
     *
     * Note: Care should be given to handle size discrepancies between
     * input and output values if the Strings are part of a structured
     * data set (e.g. column-oriented data file).
     */
    public String transform( Matcher mr );
}
