/***
 * Excerpted from "No Fluff Just Stuff 2006 Anthology"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/nfjs06 for more book information.
***/
package com.kirkk.test;

import junit.framework.*;
import junit.textui.*;
import jdepend.framework.*;

public class DependencyConstraintTest extends TestCase {
    private JDepend jDepend;
    
    public static void main(String[] args) {
	junit.textui.TestRunner.run(DependencyConstraintTest.class);
    }
    
    public DependencyConstraintTest(String name) {
	super(name);
    }
    

    protected void setUp() throws Exception {
	PackageFilter filter = new PackageFilter();
	filter.addPackage("java.*");
	jDepend = new JDepend(filter);
	jDepend.addDirectory("build/com/kirkk/cust");
	jDepend.addDirectory("build/com/kirkk/bill");
    }
    
    public void testPackageDependencies() {
	DependencyConstraint constraint = new DependencyConstraint();
	
	JavaPackage cust = constraint.addPackage("com.kirkk.cust");
	JavaPackage bill = constraint.addPackage("com.kirkk.bill");
	
	cust.dependsUpon(bill);
	jDepend.analyze();
	assertEquals("Dependency Mismatch", true, 
		     jDepend.dependencyMatch(constraint));
	
    }
    
    public void testCycles() {
	java.util.Collection packages = jDepend.analyze();
	assertEquals("Cycles exist", false, jDepend.containsCycles());
    }
}