/***
 * Excerpted from "No Fluff Just Stuff 2006 Anthology"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/nfjs06 for more book information.
***/
package com.nealford.conf.nfjs.domainlangs.exerlang;

import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.TokenStreamException;

import java.io.DataInputStream;
import java.io.Reader;
import java.io.FileReader;
import java.io.FileNotFoundException;

/*START:main*/
public class Main {

    public static void main(String[] args) {
        Reader reader = null;
        try {
            reader = new FileReader(args[0]);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        // attach lexer to the input stream
        ExerlangLexer lexer = new ExerlangLexer(reader);

        // Create parser attached to lexer
        ExerlangParser parser = new ExerlangParser(lexer);

        // start up the parser by calling the rule
        // at which you want to begin parsing.

        try {
            parser.series();
       

            // Get the tree out of the parser
            AST resultTree = parser.getAST();

            // Make an instance of the tree parser
            ExerLangTreeParser treeParser = new ExerLangTreeParser();

            treeParser.sum(resultTree);  // walk AST once
        } catch (RecognitionException e) {
            e.printStackTrace();
        } catch (TokenStreamException e) {
            e.printStackTrace();  
        }
    }
}
/*END:main*/
