/*START:lexer*/
class ExerlangLexer extends Lexer;

EXERCISE : "swim"
         | "bike"
         | "run"
         ;

WS       :  (' '
         |  '\t'
         |  '\n'
         |  '\r')
               { _ttype = Token.SKIP; }
         ;

ON       : "on";

FOR      : "for";

DISTANCE :  (DIGIT)+ ;

protected
DIGIT    : '0'..'9';

WEEKDAY  : "MON"
         | "TUE"
         | "WED"
         | "THU"
         | "FRI"
         | "SAT"
         | "SUN"
         ;

SUMMARY : "summary" ; 
/*END:lexer*/

/*START:parser*/
class ExerlangParser extends Parser;

options {
    buildAST = true;
}

series
    : EXERCISE ON! WEEKDAY FOR! DISTANCE
    | SUMMARY
    ;

class ExerLangTreeParser extends TreeParser;
{
    int swim = 0;
    int bike = 0;
    int run = 0;
}

sum
    : e:EXERCISE

        d:WEEKDAY {
            System.out.print("on " + d.getText());
        }

        dist:DISTANCE {
            System.out.println(" went " + dist.getText());
            if (e.getText().equals("swim"))
                swim += Integer.parseInt(dist.getText());
             else if (e.getText().equals("bike"))
                bike += Integer.parseInt(dist.getText());
            else
                run += Integer.parseInt(dist.getText());
        }
    ;

total
    : SUMMARY {
            System.out.println("Summary: \n------------------");
            System.out.println("Swim: " + swim);
            System.out.println("Bike: " + bike);
            System.out.println("Run:" + run);
        }
    ;
/*END:parser*/
