/***
 * Excerpted from "No Fluff Just Stuff 2006 Anthology"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/nfjs06 for more book information.
***/
package com.nealford.conf.nfjs.domainlangs.exerlog;

import java.util.Calendar;
import java.util.Date;
import java.text.SimpleDateFormat;

/**
 * Created by IntelliJ IDEA.
 * User: nford
 * Date: Mar 5, 2005
 * Time: 10:20:04 AM
 * Subversion Properties:
 * $LastChangedDate: 2005-03-05 12:30:20 -0500 (Sat, 05 Mar 2005) $
 * $LastChangedRevision: 116 $
 * $HeadURL: svn://neal4d.is-a-geek.com/svn/dev/java/intellij/nfjs_domainlangs_exerlog/trunk/src/com/nealford/conf/nfjs/domainlangs/exerlog/Exercise.java $
 */
 /*START: Exercise*/
abstract public class Exercise {
    private Calendar date;
    private double distance;
    private DistanceUnitOfMeasure units;

    public Calendar getDate() {
        return date;
    }

    public Exercise onDate(Calendar date) {
        this.date = date;
        return this;
    }

    public double getDistance() {
        return distance;
    }

    public Exercise forDistance(int distance) {
        this.distance = distance;
        return this;
    }

    public Exercise forDistance(double distance) {
        this.distance = distance;
        return this;
    }

    public Exercise onDate(String dateString) {
        Calendar c = Calendar.getInstance();
        String month = dateString.substring(0, dateString.indexOf('/'));
        String day = dateString.substring(dateString.indexOf("/") + 1,
                dateString.lastIndexOf("/"));
        String year = dateString.substring(dateString.lastIndexOf("/") + 1,
                dateString.length());
        c.set(Calendar.MONTH, Integer.parseInt(month) - 1);
        c.set(Calendar.DATE, Integer.parseInt(day));
        c.set(Calendar.YEAR, Integer.parseInt(year));
        date = c;
        return this;
    }

    public DistanceUnitOfMeasure getUnits() {
        return units;
    }

    public Exercise inUnits(DistanceUnitOfMeasure units) {
        this.units = units;
        return this;
    }

    public void add(Calendar date, int distance, DistanceUnitOfMeasure units) {

    }

    abstract public String getType();

    public String report() {
        StringBuffer buf = new StringBuffer(100);
        buf.append("On ").
            append(new SimpleDateFormat("EEE, MMM d, yyyy").format(
                    new Date(date.getTimeInMillis()))).
            append(" ").
            append(getType()).
            append(" for distance of ").
            append(distance).
            append(" ").
            append(units.toString());
        return buf.toString();
    }
}
/*END: Exercise*/
